require 'uu/os/rest/dto'
require 'uu/os/uesuri'



module UU
  module OS
    module AppMetaModel
      class AppMetaModelInstallSharedMetaModelAppParameters < UU::OS::REST::DTO

        def to_camel snake
          parts = snake.split("_")
      
          for i in 1..parts.size-1
            parts[i] = parts[i].capitalize
      
          end
          return parts.join
      
        end
        
        def camelize_hash(the_hash )
         if !the_hash.nil?
      
          the_hash.keys.each do |k|
      
            if the_hash[k].is_a?(Hash)
              camelize_hash(the_hash[k])
              the_hash[to_camel(k.to_s).to_sym] = the_hash.delete k
            elsif the_hash[k].is_a?(Array)
                   the_hash[k].each { |h| camelize_hash(h) }
            else
              the_hash[to_camel(k.to_s).to_sym] = the_hash.delete k
              end
          end
      
          return the_hash
         end
        end
          
        def camelize_array(array)
          array.each {|the_hash|
            camelize_hash(the_hash)
          }
        end
          
        # @see AppMetaModel#install_shared_meta_model
        attr_accessor :app_box_uri

        # @see AppMetaModel#install_shared_meta_model
        attr_accessor :app_identities
        
        # @see AppMetaModel#install_shared_meta_model
        attr_accessor :app_installation_config
        
        # @see AppMetaModel#install_shared_meta_model
        attr_accessor :app_identity_cast_list
        
        # @see AppMetaModel#install_shared_meta_model
        attr_accessor :dev_system_space_uri

        # @see AppMetaModel#install_shared_meta_model
        attr_accessor :dev_app_space_uri

        # @see AppMetaModel#install_shared_meta_model
        attr_accessor :dev_meta_model_suffix

        # @see AppMetaModel#install_shared_meta_model
        attr_accessor :dev_shared_space_uri
        
        # @see AppMetaModel#install_shared_meta_model
        attr_accessor :appLimits
        
        # @see AppMetaModel#install_shared_meta_model
        attr_accessor :force

        def app_box_uri
          attributes[:appBoxUri]
        end

        def app_box_uri=(val)
          if val
            attributes[:appBoxUri] = UU::OS::UESURI.new(val)
          else
            attributes[:appBoxUri] = nil
          end
        end
        
        def app_limits
          attributes[:appLimits]
        end

        def app_limits=(val)
          attributes[:appLimits] = val
        end

        def app_identities
          attributes[:appIdentities]
        end

        def app_identities=(val)
          attributes[:appIdentities] = camelize_array(val)
        end

        def app_installation_config
          attributes[:appInstallationConfig]
        end

        def app_installation_config=(val)
          attributes[:appInstallationConfig] = val
        end
        
        def app_identity_cast_list
          attributes[:appIdentityCastList]
        end

        def app_identity_cast_list=(val)
          attributes[:appIdentityCastList] = camelize_array(val)
        end

        def dev_meta_model_suffix
          attributes[:devMetaModelSuffix]
        end

        def dev_meta_model_suffix=(val)
          attributes[:devMetaModelSuffix] = val
        end

        def dev_system_space_uri
          attributes[:devSystemSpaceUri]
        end

        def dev_system_space_uri=(val)
          if val
            attributes[:devSystemSpaceUri] = UU::OS::UESURI.new(val)
          else
            attributes[:devSystemSpaceUri] = nil
          end
        end
        
        def dev_app_space_uri
          attributes[:devAppSpaceUri]
        end

        def dev_app_space_uri=(val)
          if val
            attributes[:devAppSpaceUri] = UU::OS::UESURI.new(val)
          else
            attributes[:devAppSpaceUri] = nil
          end
        end
        
        def dev_shared_space_uri
          attributes[:devSharedSpaceUri]
        end

        def dev_shared_space_uri=(val)
          if val
            attributes[:devSharedSpaceUri] = UU::OS::UESURI.new(val)
          else
            attributes[:devSharedSpaceUri] = nil
          end
        end
        
        def force
          attributes[:force]
        end
        
        def force=(val)
          attributes[:force] = val
        end
      end
    end

  end
end
