require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS
    module ImageCatalog

      # DTO representing image entry in an image list.
      class ImageCatalogImageEntryAttributes < UU::OS::REST::DTO

        # URI of the image.
        # @return [UU::OS::UESURI]
        attr_accessor :uri

        # Name of the image.
        # @return [String]
        attr_accessor :name

        # Code of the image.
        # @return [String]
        attr_accessor :code

        # List of tags of the image.
        # @return [Array<String>]
        attr_accessor :tag_list

        def uri
          attributes[:uri]
        end

        def uri=(val)
          if val
            attributes[:uri] = UU::OS::UESURI.new(val)
          else
            attributes[:uri] = nil
          end
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end
        
        def tag_list
          attributes[:tagList]
        end
        
        def tag_list=(val)
          attributes[:tagList] = val
        end

      end
    end
  end
end
