require 'uu/os/rest/dto'

module UU
  module OS
    module Sheet
      class SheetGetVersionData < UU::OS::REST::DTO
        
        # Id of version which data will be retrieved by command.
        attr_accessor :version_id
        
        # Format of data retrieved by command. Only possible value is 'application/ues-content-xml'.
        # @see UU::OS::Sheet::MimeType
        attr_accessor :requested_mime_type
        
        def version_id
          attributes[:versionID]
        end

        def version_id=(val) 
          attributes[:versionID] = val
        end
        
        def requested_mime_type 
          attributes[:requestedMimeType]
        end

        def requested_mime_type=(val) 
          attributes[:requestedMimeType] = val
        end
        
      end
    end
  end
end